## piuparts 0.48ubuntu1

=== Makefile ===
prefix = /usr/local
sbindir = $(prefix)/sbin
sharedir = $(prefix)/share
mandir = $(sharedir)/man
man1dir = $(mandir)/man1
libdir = $(prefix)/lib
docdir = $(prefix)/share/doc/piuparts/
site26 = $(libdir)/python2.6/dist-packages
site27 = $(libdir)/python2.7/dist-packages
htdocsdir	 = $(sharedir)/piuparts/htdocs
etcdir = $(prefix)/etc

distribution=${shell dpkg-parsechangelog | sed -n 's/^Distribution: *//p'}
ifeq ($(distribution),UNRELEASED)
version		:= ${shell echo "`dpkg-parsechangelog | sed -n 's/^Version: *//p'`~`date +%Y%m%d%H%M`~`git describe --dirty`"}
else
version		:= ${shell dpkg-parsechangelog | sed -n 's/^Version: *//p'}
endif


all: install install-doc

build-doc:
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README.txt
	a2x -f manpage piuparts.1.txt
	a2x --copy -f xhtml piuparts.1.txt

install-doc:
	install -d $(docdir)/
	for file in README.txt README.html docbook-xsl.css ; do \
	    install -m 0644 $$file $(docdir)/ ; done
	install -d $(man1dir)
	install -m 0644 piuparts.1 $(man1dir)
	gzip -9f $(man1dir)/piuparts.1
	install -m 0644 piuparts.1.html $(docdir)

install-conf:
	install -d $(etcdir)/piuparts
	install -m 0644 conf/piuparts.conf.sample $(etcdir)/piuparts/piuparts.conf

	install -d $(etcdir)/cron.d
	install -m 0644 conf/crontab-master $(DESTDIR)$(etcdir)/cron.d/piuparts-master
	install -m 0644 conf/crontab-slave $(DESTDIR)$(etcdir)/cron.d/piuparts-slave
	sed -i -r '/^[^#]+/s/^/#/' $(etcdir)/cron.d/piuparts-*

	install -d $(etcdir)/sudoers.d
	install -m 440 conf/piuparts.sudoers $(etcdir)/sudoers.d/piuparts
	sed -i -r '/^[^#]+/s/^/#/' $(etcdir)/sudoers.d/piuparts

	install -d $(etcdir)/apache2/conf.d
	install -m 0644 conf/piuparts.apache $(etcdir)/apache2/conf.d

install-conf-4-running-from-git:
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/crontab-master $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/crontab-slave $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 instances/forward.* $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 instances/piuparts.conf.* $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 update-piuparts-setup $(DESTDIR)$(sharedir)/piuparts/slave/

build:
	for file in piuparts piuparts-slave piuparts-master piuparts-report piuparts-analyze; do \
		sed -e 's/__PIUPARTS_VERSION__/$(version)/g' $$file.py > $$file ; done

install:
	install -d $(sbindir)
	install -m 0755 piuparts $(DESTDIR)$(sbindir)/piuparts

	install -d $(sharedir)/piuparts
	for file in piuparts-slave piuparts-master piuparts-report piuparts-analyze; do \
		install -m 0755 $$file $(DESTDIR)$(sharedir)/piuparts/$$file ; done

	install -d $(site26)/piupartslib
	install -d $(site27)/piupartslib
	install -m 0644 piupartslib/*.py $(site26)/piupartslib
	install -m 0644 piupartslib/*.py $(site27)/piupartslib

	install -d $(sharedir)/piuparts/master
	install -m 0755 master-bin/* $(DESTDIR)$(sharedir)/piuparts/master

	install -d $(DESTDIR)$(sharedir)/piuparts/master/known_problems
	install -m 0644 known_problems/*.conf $(DESTDIR)$(sharedir)/piuparts/master/known_problems/

	install -d $(sharedir)/piuparts/slave
	install -m 0755 slave-bin/* $(DESTDIR)$(sharedir)/piuparts/slave

	install -d $(DESTDIR)$(htdocsdir)
	install -m 0644 htdocs/*.* $(DESTDIR)$(htdocsdir)/

	install -d $(DESTDIR)$(htdocsdir)/images
	install -m 0644 htdocs/images/*.* $(DESTDIR)$(htdocsdir)/images/
	ln -sf /usr/share/icons/Tango/24x24/status/sunny.png $(DESTDIR)$(htdocsdir)/images/sunny.png
	ln -sf /usr/share/icons/Tango/24x24/status/weather-severe-alert.png $(DESTDIR)$(htdocsdir)/images/weather-severe-alert.png

	install -d $(DESTDIR)$(htdocsdir)/templates/mail
	install -m 0644 bug-templates/*.mail $(DESTDIR)$(htdocsdir)/templates/mail/

	install -d $(DESTDIR)$(etcdir)/piuparts
	for d in $$(ls custom-scripts) ; do \
		install -d $(DESTDIR)$(etcdir)/piuparts/$$d ; \
		install -m 0755 custom-scripts/$$d/* $(DESTDIR)$(etcdir)/piuparts/$$d/ ; done

	#install -d $(DESTDIR)$(etcdir)/piuparts/known_problems
	#install -m 0644 known_problems/*.conf $(DESTDIR)$(etcdir)/piuparts/known_problems/


check:
	python piuparts.py unittest
	python unittests.py

clean:
	rm -f piuparts piuparts-slave piuparts-master piuparts-report piuparts-analyze
	rm -f piuparts.1 piuparts.1.xml piuparts.1.html README.xml README.html docbook-xsl.css piuparts.html
	rm -f *.pyc piupartslib/*.pyc

=== debian/changelog ===
piuparts (0.48ubuntu1) raring; urgency=low

  * Merge from Debian unstable. Remaining Ubuntu changes:
   - In Ubuntu, debfoster tries to remove packages with priority
     required even if MaxPriority=required is used. Setting MaxPriority
     to important reduces the number of packages to be removed as well
     as false positives generated by unwanted package removals. This can
     be dropped if a proper fix for debfoster is found.
   - piuparts.py: Set default keyring name to ubuntu-archive-keyring.pgp
   - Set default distribution to raring.

 -- Andrew Starr-Bochicchio <a.starr.b@gmail.com>  Sun, 02 Dec 2012 14:47:08 -0500

piuparts (0.48) unstable; urgency=low

  [ Andreas Beckmann ]
  * piuparts.py:
    - Ignore *.dpkg-* conffile backups found in --scriptsdir directories.
    - Report attributes (for reference and current file) in case of file
      modification.
    - Report paths of installed files that contain symlinks (for better
      debugging of the problems caused by such a setup).
      ( test $(dirname $x) != $(readlink -f $(dirname $x)) )
    - Add debsums, processes, and broken-symlinks check after the first purge
      in --install-purge-install mode.
    - Add --install-recommends option, disabled by default.
    - Mark temporary directories with a .piuparts.tmpdir file.
    - Use rm -rf --one-file-system to delete chroots.
  * piuparts.conf:
    - New per section settings: expire-old-days, expire-fail-days (defaulting
      to 0 which means expiration is disabled).
    - Split and rename piuparts-cmd into piuparts-command ([global] setting
      that should include all common flags) and piuparts-flags (for additional
      section-specific flags).
    - Rename the tempdir setting to tmpdir, this will be used for the --tmpdir
      argument of piuparts, too.
  * piuparts-master.py:
    - Enable recycling before initializing the real package db.
    - Enable logging by default and set default log-file to
      $SECTION/master.log. Use "/dev/null" to disable logging.
  * piuparts-slave.py:
    - Retry sections with higher precedence more often.
    - Construct the piuparts command line from the new config options
      piuparts-command, piuparts-flags, and tmpdir.
  * piuparts-report.py:
    - Don't hardcode section names, always show all known_problem reports.
  * detect_piuparts_issues: Catch the chroot running out of space.
  * reschedule_oldest_logs: Implement logfile expiration. Delete logfiles that
    are marked for recycling and are older than expire-{old,fail}-days. These
    packages have not been retested because of some dependency problem making
    the package currently untestable. Deleting the log will cause the package
    to be moved to dependency-failed-testing or similar state.
    expire-*-days needs to be greater than reschedule-*-days to enable this.
  * slave_cleanup: Only remove directories containing a .piuparts.tmpdir file.
  * New bug template: copyright_file_missing_after_upgrade.
  * New known problem: Installing something over existing symlinks.

 -- Holger Levsen <holger@debian.org>  Fri, 30 Nov 2012 12:12:09 +0100

piuparts (0.47ubuntu1) raring; urgency=low

  * Merge from Debian unstable. Remaining Ubuntu changes:
   - In Ubuntu, debfoster tries to remove packages with priority
     required even if MaxPriority=required is used. Setting MaxPriority
     to important reduces the number of packages to be removed as well
     as false positives generated by unwanted package removals. This can
     be dropped if a proper fix for debfoster is found.
   - piuparts.py: Set default keyring name to ubuntu-archive-keyring.pgp
  * Set default distribution to raring.

 -- Andrew Starr-Bochicchio <a.starr.b@gmail.com>  Mon, 05 Nov 2012 22:52:54 -0500

piuparts (0.47) unstable; urgency=low

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files/ignored_patterns:
      + /var/log/dbconfig-common/dbc.log
    - Print a final message before terminating in the panic() handler.
    - Add support for running debsums before package removal, enabled by
      default. May be disabled via --no-debsums.  (Closes: #687538)
    - Add debsums as dependency.
  * piuparts-slave.py:
    - Detect incomplete piuparts output and ensure such tests fail.
  * piuparts-report.py:
    - Rewrite find_files_with_suffix(), handle disappearing files.
  * New custom script pre_remove_50_find_missing_copyright: check for missing
    /usr/share/doc/$package/copyright files.  (Closes: #683685)
  * Rename custom script post_install_find_bad_permissions to
    pre_remove_50_find_bad_permissions to avoid early failures during upgrade
    tests that may be fixed in a later version.
  * Remove post_purge_dbconfig_cleanup custom script.
  * reschedule_oldest_logs: Refactored.
    - Fix duplicate variable name usage that sometimes prevented recycling.
    - Support a [global] auto-reschedule=no setting.
  * detect_well_known_errors: Unclassified logs may still be bugged.
  * detect_piuparts_issues: Detect incomplete logfiles.
  * New bug template: modifies_conffiles.
  * New known problem: Modifying conffiles or other shipped files.
  * New custom script post_distupgrade_hack_debsums to work around #687611
    which makes all debsum checks fail due to modification of
    /usr/share/keyrings/debian-archive-removed-keys.gpg during upgrades.

 -- Holger Levsen <holger@debian.org>  Fri, 28 Sep 2012 13:24:47 +0200

piuparts (0.46) unstable; urgency=low

  [ Holger Levsen ]
  * piuparts-report: drop in-code index.tpl stub.
  * slave-join: fix bug preventing detection that the slave is not running.
  * piuparts: call schroot with session: argument, thanks to Stephan Sürken
    for the patch. (Closes: #686360)

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files/ignored_patterns:
      + /var/lib/cdebconf/{questions,templates}.dat-old
      + /var/lib/onioncat/
      + /var/lib/vmm/(./.*)?    (Closes: #682184)


=== debian/control ===
Source: piuparts
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
Uploaders:
 Holger Levsen <holger@debian.org>
Section: devel
Priority: extra
Standards-Version: 3.9.3
Build-Depends:
 debhelper (>= 8.1.0~),
 python (>=2.6.6-3~),
Build-Depends-Indep:
 asciidoc,
 git,
 xmlto
Homepage: http://piuparts.debian.org
Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
X-Python-Version: >= 2.6

Package: piuparts
Architecture: all
Pre-Depends:
 dpkg (>= 1.15.7.2~),
Depends:
 debootstrap,
 debsums,
 lsb-release,
 lsof,
 python-debian,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 schroot
Description: .deb package installation, upgrading, and removal testing tool
 piuparts tests that .deb packages (as used by Debian) handle
 installation, upgrading, and removal correctly. It does this by
 creating a minimal Debian installation in a chroot, and installing,
 upgrading, and removing packages in that environment, and comparing the
 state of the directory tree before and after. piuparts reports any
 files that have been added, removed, or modified during this process.
 .
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.

Package: piuparts-master
Architecture: all
Depends:
 piuparts-common (= ${binary:Version}),
 adduser,
 openssh-server,
 python-debianbts,
 ${misc:Depends},
 ${python:Depends}
Recommends:
 apache2,
 ghostscript,
 python-rpy,
 r-base-dev,
 r-recommended,
 tango-icon-theme
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts master components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on http://piuparts.debian.org/.
 .
 This package provides the piuparts-master, which needs one or more slaves to
 operate. It also contains piuparts-reports to generate web pages with the
 testing results as well as documentation.

Package: piuparts-slave
Architecture: all
Depends:
 piuparts (= ${binary:Version}),
 piuparts-common (= ${binary:Version}),
 adduser,
 openssh-client,
 screen,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 schroot
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts slave components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on http://piuparts.debian.org/.
 .
 This package provides the piuparts slave components, which need a piuparts
 master to operate. See the documentation in the piuparts-master package.

Package: piuparts-common
Architecture: all
Depends:
 python-apt,
 ${misc:Depends},
 ${python:Depends}
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: common piuparts components
 piupartslib, common library used by piuparts-master, -reports, -analyze and
 -slave.
 .
 See http://piuparts.debian.org or the piuparts package to learn more about
 piuparts.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python2


override_dh_auto_build:
	$(MAKE) build build-doc

override_dh_auto_test:
	echo "unittests are disabled as they haven't been run at build time since years and thus are broken..."

override_dh_auto_install:
	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr etcdir=$(CURDIR)/debian/tmp/etc install install-doc install-conf

override_dh_python2:
	dh_python2 -p piuparts-master -p piuparts-slave /usr/share/piuparts
	dh_python2 -N piuparts-master -N piuparts-slave

## piuparts 0.53

=== debian/changelog ===
piuparts (0.53) unstable; urgency=low

  [ Andreas Beckmann ]
  * piuparts.py:
    - Do not run adequate checks on possibly disappearing packages.
    - Add --allow-database option that enables starting MySQL and PostgreSQL
      database servers in the chroot. (Closes: #662633)
    - Relax the check for running processes if --allow-database is given.
  * distros.conf:
    - Add "candidates" key to merge multiple Packages files into one virtual
      distro.
    - Define wheezy-proposed and squeeze-proposed.
  * piupartslib/conf.py:
    - Add get_{packages,sources}_urls() that resolve "candidates".
  * piupartslib/packagesdb.py:
    - Add load_packages_urls() methods.
  * piuparts-{master-backend,slave,report}.py:
    - Switch to load_*_urls(get_*_urls()) for loading Packages/Sources files,
      adding support for arbitrarily composed virtual distros.
  * Makefile:
    - Stop installing python modules in $libdir/python2.6/dist-packages.
  * debian/control:
    - Bump Build-Depends: python (>= 2.7).
    - piuparts-slave: Add Depends: sudo.  (Closes: #710350)
  * New known problem: Packages with missing or incomplete .md5sums files.
  * piuparts-master.deb: Ship some piuparts.conf examples.
  * detect_piuparts_issues: Detect problems starting MySQL or PostgreSQL.
  * pre_install_database-server: New script to install a database server for
    packages that require one during postinst but only recommend or suggest
    (or maybe not even this) the server package to allow for remote db
    servers.
  * pre_distupgrade_zz_database-server: New script to upgrade (running)
    database servers before all other packages. This ensures the database
    server is running again before the dependent packages (that may declare
    'insufficient' dependencies on a 'local' database server) are upgraded.

  [ David Steele ]
  * Update python Requires to 2.7 (for argparse)
  * Edit piuparts_slave_* man pages for more information and format.
  * Specify the manpage doctype for AsciiDoc man sources.

  [ Holger Levsen ]
  * piuparts.1.txt, README.txt and README_pejacevic.txt: proof-read and
    cleaned up.
  * Move master-slave related documentation from README.txt to
    README_server.txt and leave a pointer in the former.
  * Rename README.txt to README_1st.txt.
  * piuparts-master.deb:
    - Ship README_server.txt.
    - Recommend devscripts and libsoap-lite-perl (for gather_bts_stats).
  * piuparts-report.py: Add a link to README_server.html.
  * master-bin/gather_bts_stats: write bts_stats.txt to master-directory.
  * conf/crontab-master: run gather_bts_stats daily.
  * master-bin/prepare_backup: backup bts_stats.txt and do not backup
    sources.txt.
  * piuparts.py: categorize adequate results using inadequate_tags,
    boring_tags, ignored_tags and unknown. Show adequate exit code if
    non-zero.
  * Add known_problems/*inadequate*.conf for all adequate tags we care about.
  * htdocs/index.tpl: Improve description about piuparts.debian.org.
    (Closes: #700848)

  [ Andrew Starr-Bochicchio ]
  * piuparts.py:
    - Move default keyring to distro defaults.  (Closes: #710346)
    - When distro defaults are explicitly specified, use the distro default
      mirrors (Closes: #710347).

 -- Holger Levsen <holger@debian.org>  Sun, 09 Jun 2013 12:57:52 +0200

piuparts (0.52) unstable; urgency=low

  [ Andreas Beckmann ]
  * piuparts.py:
    - Really disable PDiffs.  (Closes: #708241)
  * piuparts-master.in:
    - Use timeout to prevent master from getting stuck.  (Closes: #701618)
  * piuparts-slave.py:
    - Report upgrade tests involving downgrades as untestable.
    - Always pass --arch <arch> to piuparts.
  * piuparts-analyze.py:
    - Consider archived bugs, too.  (Closes: #669966)
  * piuparts-report.py:
    - Switch from python-rpy to python-rpy2.  (Closes: #705975)
    - rpy2: Use a noninteractive grDevice.
  * Makefile:
    - Switch default target from 'install' to 'build'.
  * scripts-no-usr-share-doc/post_setup_disable_usr_share_doc: New custom
    script to instruct dpkg to skip installing most files in /usr/share/doc.
    This catches maintainer scripts relying on /usr/share/doc content.
  * New bug template: postinst_uses_usr_share_doc.
  * piuparts-master.deb:
    - Switch Depends: python-rpy to Depends: python-rpy2.

  [ Holger Levsen ]
  * piuparts.py:
    - Run adequate (if installed) after installation test. New options
      --no-adequate and --fail-if-inadequate. (Closes: #703902)
    - Workaround #709372 and ignore broken symlinks found by adequate.
    - Do not print a "Guessed: debian" line on every run. It's the default
      anyway. (Closes: #703058)
  * piuparts-report:
    - Add templates for known_problems/inadequate_issue and inadequate_error.
    - Add link to the piuparts source at the top of the navigation menu on the
      left.
    - Add links to Debian QA group and jenkins.debian.net at the bottom of
      that navigation menu.
  * debian/control: Add adequate to piuparts' recommends.
  * piuparts-slave.postrm: Also remove /var/cache/piuparts/tmp on purge.
  * conf/crontab-master: Run generate_daily_report twice a day.
  * piuparts-slave.deb: Add piuparts_slave_run.8 and piuparts_slave_join.8
    manpages.

 -- Holger Levsen <holger@debian.org>  Mon, 27 May 2013 18:10:43 +0200

piuparts (0.51) unstable; urgency=low

  [ Andreas Beckmann ]
  * Mark all python code as utf-8 encoded.
  * piuparts.py:
    - In install-purge tests support installing extra packages before the
      package to be tested via --extra-old-packages.
    - Add --arch <arch> option to run the test for the requested instead of
      the default architecture.
    - Disable using PDiffs in order to save CPU instead of bandwidth to a
      local mirror/proxy.  (Closes: #708241)
  * piuparts.conf:
    - New global settings:
      + slave-count
    - Use installation-dependent defaults for known-problem-directory.
  * distros.conf:
    - Update backports setup after integration into the regular archive.


=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: piuparts
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders:
  Holger Levsen <holger@debian.org>
 Section: devel
 Priority: extra
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Build-Depends:
  debhelper (>= 8.1.0~),
- python (>=2.6.6-3~),
+ python (>= 2.7),
 Build-Depends-Indep:
  asciidoc,
  git,
@@ -16,13 +15,14 @@
 Homepage: http://piuparts.debian.org
 Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
-X-Python-Version: >= 2.6
+X-Python-Version: >= 2.7
 
 Package: piuparts
 Architecture: all
 Pre-Depends:
  dpkg (>= 1.15.7.2~),
 Depends:
+ piuparts-common (= ${binary:Version}),
  debootstrap,
  debsums,
  lsb-release,
@@ -30,6 +30,8 @@
  python-debian,
  ${misc:Depends},
  ${python:Depends}
+Recommends:
+ adequate
 Suggests:
  schroot
 Description: .deb package installation, upgrading, and removal testing tool
@@ -50,15 +52,17 @@
  adduser,
  openssh-server,
  python-debianbts,
+ tango-icon-theme,
+ xz-utils,
  ${misc:Depends},
  ${python:Depends}
 Recommends:
  apache2,
  ghostscript,
- python-rpy,
+ python-rpy2,
  r-base-dev,
  r-recommended,
- tango-icon-theme
+ devscripts, libsoap-lite-perl,
 Breaks:
  piuparts (<= 0.44)
 Replaces:
@@ -81,6 +85,7 @@
  adduser,
  openssh-client,
  screen,
+ sudo,
  ${misc:Depends},
  ${python:Depends}
 Suggests:

## piuparts 0.56ubuntu1

=== Makefile ===
prefix = /usr/local
sbindir = $(prefix)/sbin
sharedir = $(prefix)/share
mandir = $(sharedir)/man
man1dir = $(mandir)/man1
man8dir = $(mandir)/man8
libdir = $(prefix)/lib
docdir = $(prefix)/share/doc/piuparts/
site27 = $(libdir)/python2.7/dist-packages
htdocsdir	 = $(sharedir)/piuparts/htdocs
etcdir = $(prefix)/etc

distribution=${shell dpkg-parsechangelog | sed -n 's/^Distribution: *//p'}
ifeq ($(distribution),UNRELEASED)
version		:= ${shell echo "`dpkg-parsechangelog | sed -n 's/^Version: *//p'`~`date +%Y%m%d%H%M`~`git describe --dirty`"}
else
version		:= ${shell dpkg-parsechangelog | sed -n 's/^Version: *//p'}
endif


# generate several scripts, conffiles, ... from templates (*.in, *.py)
# by substituting placeholders
SCRIPTS_TEMPLATES	 = $(wildcard *.in master-bin/*.in slave-bin/*.in conf/*.in)
SCRIPTS_PYTHON_BINARY	 = $(wildcard *.py master-bin/*.py slave-bin/*.py)
SCRIPTS_GENERATED	 = $(SCRIPTS_TEMPLATES:.in=) $(SCRIPTS_PYTHON_BINARY:.py=)
DOCS_GENERATED		 = piuparts.1 piuparts.1.html piuparts_slave_run.8 piuparts_slave_join.8 README_1st.html README_server.html

define placeholder_substitution
	sed -r \
	-e 's/__PIUPARTS_VERSION__/$(version)/g' \
	-e 's%@sharedir@%$(sharedir)%g' \
	$< > $@
endef

%: %.in Makefile
	$(placeholder_substitution)

%: %.py Makefile
	$(placeholder_substitution)


all: build

python_scripts	 = $(wildcard *.py piupartslib/*.py master-bin/*.py slave-bin/*.py)
python-syntax-check:
	@set -e -x; $(foreach py,$(python_scripts),python -m py_compile $(py);)
	$(RM) $(python_scripts:=c)

build: build-stamp

build-stamp: $(SCRIPTS_GENERATED) $(DOCS_GENERATED) Makefile
	$(MAKE) python-syntax-check
	touch $@

build-doc: $(DOCS_GENERATED)

README_1st.html: README_1st.txt
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README_1st.txt

README_server.html: README_server.txt
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README_server.txt

piuparts.1: piuparts.1.txt
	a2x -f manpage piuparts.1.txt

piuparts_slave_run.8: piuparts_slave_run.8.txt
	a2x -f manpage piuparts_slave_run.8.txt

piuparts_slave_join.8: piuparts_slave_join.8.txt
	a2x -f manpage piuparts_slave_join.8.txt

piuparts.1.html: piuparts.1.txt
	a2x --copy -f xhtml piuparts.1.txt

install-doc: build-stamp
	install -d $(DESTDIR)$(docdir)/
	install -m 0644 README_1st.txt README_1st.html README_server.txt README_server.html docbook-xsl.css $(DESTDIR)$(docdir)/
	install -d $(DESTDIR)$(man1dir)
	install -m 0644 piuparts.1 $(DESTDIR)$(man1dir)/
	install -d $(DESTDIR)$(man8dir)
	install -m 0644 piuparts_slave_run.8 piuparts_slave_join.8 $(DESTDIR)$(man8dir)/
	gzip -9f $(DESTDIR)$(man1dir)/piuparts.1
	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_run.8
	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_join.8
	install -m 0644 piuparts.1.html $(DESTDIR)$(docdir)/

install-conf: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/piuparts.conf.sample $(DESTDIR)$(etcdir)/piuparts/piuparts.conf
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/

	install -d $(DESTDIR)$(etcdir)/cron.d
	install -m 0644 conf/crontab-master $(DESTDIR)$(etcdir)/cron.d/piuparts-master
	install -m 0644 conf/crontab-slave $(DESTDIR)$(etcdir)/cron.d/piuparts-slave
	# disable shipped crontabs
	sed -i -r '/^[^#]+/s/^/#/' $(DESTDIR)$(etcdir)/cron.d/piuparts-*

	install -d $(DESTDIR)$(etcdir)/sudoers.d
	install -m 440 conf/piuparts.sudoers $(DESTDIR)$(etcdir)/sudoers.d/piuparts
	# disable shipped sudoers
	sed -i -r '/^[^#]+/s/^/#/' $(DESTDIR)$(etcdir)/sudoers.d/piuparts

	install -d $(DESTDIR)$(etcdir)/apache2/conf.d
	install -m 0644 conf/piuparts.apache $(DESTDIR)$(etcdir)/apache2/conf.d/

install-conf-4-running-from-git: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/crontab-master $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/crontab-slave $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 instances/piuparts.conf.* $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 update-piuparts-slave-setup $(DESTDIR)$(sharedir)/piuparts/slave/
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 update-piuparts-master-setup $(DESTDIR)$(sharedir)/piuparts/master/

install: build-stamp
	install -d $(DESTDIR)$(sbindir)
	install -m 0755 piuparts $(DESTDIR)$(sbindir)/

	install -d $(DESTDIR)$(sharedir)/piuparts
	install -m 0755 piuparts-slave piuparts-master piuparts-master-backend piuparts-report piuparts-analyze $(DESTDIR)$(sharedir)/piuparts/

	install -d $(DESTDIR)$(site27)/piupartslib
	install -m 0644 piupartslib/*.py $(DESTDIR)$(site27)/piupartslib/

	install -d $(DESTDIR)$(sharedir)/piuparts/lib
	install -m 0644 lib/*.sh $(DESTDIR)$(sharedir)/piuparts/lib/

	# do not install the templates (*.in, *.py)
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 $(filter-out %.in %.py,$(wildcard master-bin/*)) $(DESTDIR)$(sharedir)/piuparts/master/

	install -d $(DESTDIR)$(sharedir)/piuparts/known_problems
	install -m 0644 known_problems/*.conf $(DESTDIR)$(sharedir)/piuparts/known_problems/

	# do not install the templates (*.in, *.py)
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 $(filter-out %.in %.py,$(wildcard slave-bin/*)) $(DESTDIR)$(sharedir)/piuparts/slave/

	install -d $(DESTDIR)$(htdocsdir)
	install -m 0644 htdocs/*.* $(DESTDIR)$(htdocsdir)/

	install -d $(DESTDIR)$(htdocsdir)/images
	install -m 0644 htdocs/images/*.* $(DESTDIR)$(htdocsdir)/images/

	install -d $(DESTDIR)$(htdocsdir)/templates/mail
	install -m 0644 bug-templates/*.mail $(DESTDIR)$(htdocsdir)/templates/mail/

	install -d $(DESTDIR)$(etcdir)/piuparts
	@set -e -x ; \
	for d in $$(ls custom-scripts) ; do \
		install -d $(DESTDIR)$(etcdir)/piuparts/$$d ; \
		install -m 0755 custom-scripts/$$d/* $(DESTDIR)$(etcdir)/piuparts/$$d/ ; done

	#install -d $(DESTDIR)$(etcdir)/piuparts/known_problems
	#install -m 0644 known_problems/*.conf $(DESTDIR)$(etcdir)/piuparts/known_problems/


check:
	python piuparts.py unittest
	python unittests.py

clean:
	rm -f build-stamp
	rm -f $(DOCS_GENERATED)
	rm -f piuparts.1.xml README.xml README_server.xml docbook-xsl.css piuparts.html
	rm -f *.pyc piupartslib/*.pyc master-bin/*.pyc slave-bin/*.pyc
	rm -f $(SCRIPTS_GENERATED)


# for maintainer convenience only
tg-deps:
	tg summary --graphviz | dot -T png -o deps.png
	xli deps.png &

=== debian/changelog ===
piuparts (0.56ubuntu1) trusty; urgency=medium

  * Change default Ubuntu distribution to Trusty 

 -- Zygmunt Krynicki <zygmunt.krynicki@canonical.com>  Tue, 15 Apr 2014 12:46:15 +0200

piuparts (0.56) unstable; urgency=low

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /etc/apt/apt.conf.d/01autoremove-kernels
    - Use temporary files while creating basetgz and rename afterwards.
    - Remove the package to be tested separately before removing its Depends
      and Recommends.
    - --allow-database now also enables firebird2.5-super.
  * piuparts.conf:
    - New per-section settings:
      + components
  * piupartslib/__init__.py:
    - open_packages_url(): Try Packages.gz if Packages.bz2 is not available.
      (Closes: #711157)
    - Add new class DecompressedStream.
    - open_packages_url(): Use DecompressedStream to transparently decompress
      a Packages.{bz2,gz} file while downloading and reading the content
      without requiring to store the complete file (compressed and/or
      decompressed) in memory.
  * piupartslib/packagesdb.py:
    - PackagesFile: Allow restricting to a set of package names.
  * piuparts-slave.py:
    - Use locking to prevent concurrent basetgz creation.  (Closes: #708287)
    - Use the "components" setting to restrict the archive areas being used
      in the generated sources.list.
    - Reduce memory footprint by discarding unneeded Packages file parts.
  * piuparts-report.py:
    - Report URLs of all Packages files used for a section.
    - Avoid reporting duplicate dependencies after stripping versioning.
    - Fix some invalid HTML constructs.
    - Sort maintainer summary by state: failing packages on top.
  * Improve exception handling.
  * known_problems: Upgrade adequate issue 'missing-copyright-file' from
    boring to normal and make pre_remove_50_find_missing_copyright no longer
    generate fatal errors.
  * Add support for new adequate tags missing-symbol-version-information and
    symbol-size-mismatch.
  * reschedule_oldest_logs: Report number of logfiles in recycle/.
  * Add more piuparts exceptions to work around various failures in multiple
    packages. Add a known_problem report for packages using exceptions.
  * bug-templates: Recommend to use the new dpkg-maintscript-helper commands
    dir_to_symlink/symlink_to_dir that were added in dpkg 1.17.2.
    (Closes: #720185)

  [ Holger Levsen ]
  * piuparts-report.py: use descriptive link targets for (in)adequate issues
    instead of mere tag names, thanks to Jakub Wilk for the wordings.
  * Bump standards version to 3.9.5, no changes needed.
  * Bump compat level to 9, thus build-depend on debhelper > 9.20120909~.

 -- Holger Levsen <holger@debian.org>  Mon, 16 Dec 2013 12:59:14 +0100

piuparts (0.55) unstable; urgency=low

  [ Ivo De Decker ]
  * piuparts-report.py: Add sources.yaml and section.yaml exports.

  [ Holger Levsen ]
  * Add file CONTRIBUTING, thanks to Vincent McIntyre for it! (Closes: #721348)
  * piuparts-report: Add "contact us" link.
  * piuparts.py: Explain at the very beginning of the generated log that
    contact information is part of the FAQ.

  [ Andreas Beckmann ]
  * Add bug templates for wheezy.
  * scripts-leftovers: Improve cleanup in /var/lib/systemd with fake-essential
    init-system-helpers.  (Closes: #719869)

 -- Holger Levsen <holger@debian.org>  Thu, 03 Oct 2013 15:31:38 +0200

piuparts (0.54) unstable; urgency=low

  [ Holger Levsen ]
  * known_problems: fix some adequate patterns.
  * piuparts-master: recommend apache2 | httpd.
  * README_server.txt: be more verbose about configuring sudo.
    (Closes: #711155)
  * piuparts.py and piuparts-reports.py: add "incompatible-licenses" (detected
    since adequate 0.7) and "ldd" to inadequate_tags and known_problems.

  [ David Steele ]
  * piupartslib/packagesdb.py
    - The dependency calculation for rdeps is reworked to match that used
      elsewhere, to allow package reserve() to drive waiting-for-dep to
      drive to 0 more quickly. (Closes: #705977)
    - Reworked rdep metrics (block_count, rrdep_count, waiting_count) to
      calculate on-demand. Access methods are moved from Package to
      PackagesDB.
    - Add a metric for the worst-case reverse-dependency chain length.
    - Weight the reserved packages returned by this additional factor.

  [ Andreas Beckmann ]
  * piuparts.py: add to ignored_files: /etc/hosts

 -- Holger Levsen <holger@debian.org>  Tue, 30 Jul 2013 11:05:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: piuparts
-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders:
  Holger Levsen <holger@debian.org>
 Section: devel
 Priority: extra
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Build-Depends:
- debhelper (>= 8.1.0~),
+ debhelper (>= 9.20120909~),
  python (>= 2.7),
 Build-Depends-Indep:
  asciidoc,
@@ -54,15 +55,17 @@
  python-debianbts,
  tango-icon-theme,
  xz-utils,
+ python-yaml,
  ${misc:Depends},
  ${python:Depends}
 Recommends:
- apache2,
+ apache2 | httpd,
  ghostscript,
  python-rpy2,
  r-base-dev,
  r-recommended,
- devscripts, libsoap-lite-perl,
+ devscripts,
+ libsoap-lite-perl,
 Breaks:
  piuparts (<= 0.44)
 Replaces:

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python2


override_dh_auto_build:
	$(MAKE) prefix=/usr build build-doc

override_dh_auto_test:
	echo "unittests are disabled as they haven't been run at build time since years and thus are broken..."

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp prefix=/usr etcdir=/etc install install-doc install-conf

override_dh_python2:
	dh_python2 -p piuparts-master -p piuparts-slave /usr/share/piuparts
	dh_python2 -N piuparts-master -N piuparts-slave

## piuparts 0.59

=== debian/changelog ===
piuparts (0.59) unstable; urgency=low

  [ Holger Levsen ]
  * piuparts.py:
    - mount selinuxfs read-only and on new location when possible. Thanks to
      Laurent Bigonville for the patch! (Closes: #682068)
    - Add to ignored_files:
      + /etc/sub{g,u}id[-] introduced by shadow 1:4.2-1.
  * piuparts-report.py:
    - create https URLs in source_summary_url(). This should probably be made
      configurable.
    - fix log directory creation. (Closes: #746722)
    - fix spelling of "ditto". (Closes: #746724)
    - create graph of rc and non-rc bugs filed (and fixed) since the beginning
      of piuparts testing and display it on piuparts.d.o welcome page.
    - move counts.txt from htdocs to master directory.
  * master-bin/gather_bts_stats: differate between rc and non-rc bugs.
  * Makefile:
    - Don't install crontabs and sudoers file anymore, except when
      installing from git.
    - Also cleanup python bytecode from tests.
  * Packaging:
    - install cron files for piupartsm and piupartss users in
      /usr/share/doc/piuparts-(master|slave)/examples/ (Closes: #746721)
    - split sudoers.d into master and slave and provide them in /examples/
      too.
    - install piuparts.conf.sample in /usr/share/doc/piuparts-master/examples/
    - install slave_run and slave_join in /usr/bin/ (Closes: #746718)
    - piuparts-slave.postinst: do not attempt to add the slave user's ssh
      public key to the master user's authorized key. The slave package should
      maybe recommend the master package, but definitly not pre-depend on it,
      which would be a requirement to make this work. So document this
      instead.
  * Updates various pieces of documentation, rename README_1st to README.
    Explicitly state what will break when using cdebootstrap with pbuilder.
    (Closes: #709348)
  * Update various custom-scripts (usually to workaround problems in other
    packages).
  * Switch all links to bugs.debian.org, www.debian.org, wiki.debian.org,
    packages.debian.org, anonscm.debian.org and lists.debian.org,
    db.debian.org, qa.debian.org, lists.alioth.debian.org and udd.debian.org
    to https.

  [ David Steele ]
  * dependencyparser.py - Be more lenient about the multi-arch modifiers
    accepted and stripped by the parser.
  * piuparts-report.py:
    - Fix indentation of generate_global_summary()
    - Refactor sections_by_precedence() out of generate_global_summary().
    - Restore (a copy of) the counts.txt file to the web view, in
      <section>/counts.txt.
    - Also add a link to counts.txt to the section page.
  * Remove oldstable distribution results from the JSON summary.
    - Also remote stable distribution results.

 -- Holger Levsen <holger@debian.org>  Mon, 14 Jul 2014 13:14:19 +0000

piuparts (0.58) unstable; urgency=low

  [ Holger Levsen ]
  * debian/copyright: update years.
  * piuparts.py:
    - ignore multiarch definition in_default_debian_mirrors()
      (Closes: #711370)
    - Add to ignored_files:
      + /etc/machine-id (Closes: #619244)
  * custom-scripts: add debugging output for resolvconf. (See #660350)
  * Adapt and rename conf/piuparts.apache to piuparts-master.conf as per
    apache2.4 transition. (Closes: #712384)
  * piuparts.1.txt: explain that --do-not-verify-signatures also causes
    APT::Get::AllowUnauthenticated to be set accordingly in the chroots.
  * Switch ubuntu default to 'trusty'. (Closes: #744848). Then switch it to
    'utopic'...
  * piuparts-report: Add link to ci.debian.net to navigation menu.
  * Replace http://piuparts.debian.org with https everywhere. Thanks to DSA
    for all their support running piuparts.debian.org and for everything else!

  [ Andreas Beckmann ]
  * piupartslib/packagesdb.py:
    - Add missing PackagesDB.get_version(package_name) method, needed by
      piuparts-report.
    - Add PackagesDB.get_source(package_name) method, for easy lookup of
      source package names.
  * piuparts-report.py:
    - Improve integration of known problem reports generation.
  * master-bin/detect_well_known_errors.py:
    - Classify unclassified failures as unclassified_failures.conf.

  [ David Steele ]
  * piuparts-report.py: Store test summary.json output at the section
    and global level, using a new piupartslib/pksummary.py module.
    The new Config.get_std_distro() provides a standard default distro
    name for summaries. (Closes: #740386)
  * Add python-distro-info to piuparts-common's depends and to build-depends
    as it's used in the tests too.

 -- Holger Levsen <holger@debian.org>  Thu, 01 May 2014 00:23:42 +0200

piuparts (0.57) unstable; urgency=low

  [ Ivo De Decker ]
  * piuparts-report.py: Use source version from final_distro.
    (Closes: #733900)

  [ Matthias Schmitz ]
  * Rearrange old unittests.py, use nosetests instead:
    - Move unittests.py to tests/ subdirectory,
    - Split out dependencyparser test to an extra file,
    - Add configuration for nosetests,
    - Use nosetests in Makefile target "check".
  * piuparts.py:
    - Add unittest for DefaultsFactory / Defaults.
    - Use pymox to mock the piuparts.guess_flavor() function as it would run
      lsb_release in a subprocess.
    - Move broken_symlink unittest out of piuparts.py into
      tests/test_piuparts.py so nosetests can run this test and detect
      coverage.
  * Add tests/README documenting the naming of the test classes and functions.
  * Re-enable unittests during package build
    - Don't create coverage report during pkg build.
    - Add to Build-Depends: python-debian, python-apt, python-nose,
      python-debianbts, python-yaml, and python-mox3.

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /etc/group.org
      + /etc/passwd.org
      + /etc/shadow.org
    - Create piuparts-depends-dummy.deb with gzip compression for
      installability with older dpkg versions.
    - Exclude virtual packages provided by the real package (but not the dummy


=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: piuparts
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders:
  Holger Levsen <holger@debian.org>
 Section: devel
@@ -9,13 +8,20 @@
 Build-Depends:
  debhelper (>= 9.20120909~),
  python (>= 2.7),
+ python-debian,
+ python-apt,
+ python-distro-info,
+ python-nose,
+ python-debianbts,
+ python-yaml,
+ python-mox3
 Build-Depends-Indep:
  asciidoc,
  git,
  xmlto
-Homepage: http://piuparts.debian.org
+Homepage: https://piuparts.debian.org
 Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
 X-Python-Version: >= 2.7
 
 Package: piuparts
@@ -74,7 +80,7 @@
  piuparts is meant as a quality assurance tool for people who create .deb
  packages to test them before they upload them to the Debian package archive.
  A master/slave piuparts installation is used for testing complete archives
- as it is done on http://piuparts.debian.org/.
+ as it is done on https://piuparts.debian.org/.
  .
  This package provides the piuparts-master, which needs one or more slaves to
  operate. It also contains piuparts-reports to generate web pages with the
@@ -101,7 +107,7 @@
  piuparts is meant as a quality assurance tool for people who create .deb
  packages to test them before they upload them to the Debian package archive.
  A master/slave piuparts installation is used for testing complete archives
- as it is done on http://piuparts.debian.org/.
+ as it is done on https://piuparts.debian.org/.
  .
  This package provides the piuparts slave components, which need a piuparts
  master to operate. See the documentation in the piuparts-master package.
@@ -110,6 +116,7 @@
 Architecture: all
 Depends:
  python-apt,
+ python-distro-info,
  ${misc:Depends},
  ${python:Depends}
 Breaks:
@@ -120,5 +127,5 @@
  piupartslib, common library used by piuparts-master, -reports, -analyze and
  -slave.
  .
- See http://piuparts.debian.org or the piuparts package to learn more about
+ See https://piuparts.debian.org or the piuparts package to learn more about
  piuparts.
